<?php defined('SYSPATH') or die('No direct access allowed.');
/**
 * Widget of unacknowledged service problems for tactical overview
 *
 * @package   NINJA
 * @author    op5 AB
 * @license   GPL
 */
require_once Kohana::find_file('widgets', 'tac_services_common/tac_services_base');

function sort_by_duration($a, $b) {
	return (isset($b->service_duration) ? $b->service_duration : $b->duration) - (isset($a->service_duration) ? $a->service_duration : $a->duration);
}

class tac_services_unacknowledged_Widget extends tac_services_Base {
	private function get_all_noticed() {
		$db = new Database();
		$sql = "SELECT service_id, timestamp FROM widget_service_was_noticed";
		$ary = $db->query($sql);
		$res = array();
		foreach ($ary as $obj)
			$res[$obj->service_id] = $obj->timestamp;
		return $res;
	}

	private function get_all_since_last($group)
	{
		$db = new Database();
		$last_data = isset($this->arguments['grouplog']) ? $this->arguments['grouplog'] : array();
		$result = array();
		$new_data = array();

		$shown = array();
		$shown_ary = array();
		if ($group != 'all')
			$shown_ary = $this->service($group, false, $this->state, $this->props, $this->order, $this->field, 'servicegroup');
		else
			$shown_ary = $this->service($group, false, $this->state, $this->props, $this->order, $this->field);
		$service_ids = array();
		if ($shown_ary) {
			foreach ($shown_ary as $host) {
				$service_ids[$host->service_id] = (isset($host->service_cur_time) ? $host->service_cur_time : $host->cur_time) - (isset($host->service_duration) ? $host->service_duration : $host->duration);
				$shown[] = $host;
			}
		}
		$new_data[$group] = array('timestamp' => time(), 'last_shown' => $service_ids);

		if (isset($last_data[$group]) && isset($last_data[$group]['timestamp']) && isset($last_data[$group]['last_shown'])) {
			$data = $last_data[$group];
			$timestamp = $data['timestamp'];
			$last_shown = $data['last_shown'];
			foreach ($last_shown as $id => $_) {
				$has_been_acked = $db->query(
					"SELECT COUNT(1) AS cnt FROM notification n
					INNER JOIN service s
					ON s.host_name = n.host_name
					AND s.service_description = n.service_description
					WHERE s.id = $id
					AND n.start_time > {$timestamp}
					AND ack_author IS NOT NULL");
				if ($has_been_acked->current()->cnt)
					unset($last_shown[$id]);
			}

			$groupsel = '';
			$sg_join = '';
			if ($group != 'all') {
				$groupsel = 'sg.servicegroup_name = '.$db->escape($group).' and ';
				$sg_join = 'INNER JOIN service_servicegroup ssg ON s.id = ssg.service INNER JOIN servicegroup sg ON ssg.servicegroup = sg.id';
			}
			$service_log = $db->query('
				SELECT s.id, rd.event_type, rd.state, rd.hard, rd.timestamp,
					s.host_name, s.service_description
				FROM report_data rd
				INNER JOIN service s ON rd.host_name = s.host_name
					AND rd.service_description = s.service_description
				'.$sg_join.'
				WHERE '.$groupsel.'rd.event_type IN (701, 1103, 1104)
					AND rd.timestamp >= '.$timestamp);

			$new_services = array();
			$in_downtime = array();
			$in_interesting_state = array();
			foreach ($service_log->as_array() as $obj) {
				// Check if service was in downtime last check
				// select both 1103 and 1104 to see which was last
				$init_downtime = $db->query("
					SELECT event_type
					FROM report_data
					WHERE timestamp < $timestamp
						AND event_type IN (1103, 1104)
						AND host_name = {$db->escape($obj->host_name)}
						AND service_description = {$db->escape($obj->service_description)}
					ORDER BY timestamp DESC
					LIMIT 1");
				if ($init_downtime->count())
					if ($init_downtime->current()->event_type == '1103')
						$in_downtime[$obj->id] = true;

				switch ($obj->event_type) {
				 case 1103:
					$in_downtime[$obj->id] = true;
					break;
				 case 1104:
					unset($in_downtime[$obj->id]);
					if (isset($in_interesting_state[$obj->id]))
						$new_services[$obj->id] = $obj;
					break;
				 default:
					if ($this->arguments['hard'] && !$obj->hard)
						 break;
					if (!(1 << $obj->state & $this->state)) {
						unset($in_interesting_state[$obj->id]);
						break;
					}
					$in_interesting_state[$obj->id] = true;
					if (isset($in_downtime[$obj->id]))
						break;
					$new_services[$obj->id] = $obj;
					break;
				}
			}

			foreach ($new_services as $id => $obj) {
				$has_been_acked = $db->query(
					"SELECT COUNT(1) AS cnt FROM notification
					WHERE host_name = {$db->escape($obj->host_name)}
					AND service_description = {$db->escape($obj->service_description)}
					AND start_time > {$obj->timestamp}
					AND ack_author IS NOT NULL");
				if ($has_been_acked->current()->cnt)
					unset($new_services[$id]);
			}

			$all_services = false;
			if ($group != 'all') {
				$all_services = Group_Model::get_group_info('service', $group, false, false, $this->props, false, false, $this->field, $this->order);
			} else {
				$host_model = new Host_Model();
				$host_model->show_services = true;
				$host_model->count = false;

				$host_model->set_sort_field($this->field);
				$host_model->set_sort_order($this->order);
				$host_model->serviceprops = $this->props;

				$host_model->set_host_list($group);
				$all_services = $host_model->get_host_status();
			}
			if ($all_services == false)
				$all_services = array();
			$noticed = $this->get_all_noticed();
			$shown = array();
			foreach ($all_services as $row) {
				foreach ($shown_ary as $obj) {
					if ($obj->service_id == $row->service_id) {
						$shown[] = $row;
						continue 2;
					}
				}

				foreach ($new_services as $new => $obj) {
					if ($new == $row->service_id) {
						if (!isset($noticed[$new]) || $noticed[$new] < $obj->timestamp) {
							$row->service_duration = (isset($row->service_cur_time) ? $row->service_cur_time : $row->cur_time) - $obj->timestamp;
							$shown[] = $row;
						}
						continue 2;
					}
				}

				foreach ($last_shown as $key => $timestamp) {
					if ($key == $row->service_id) {
						if (!isset($noticed[$key]) || $noticed[$key] < $timestamp) {
							$row->service_duration = (isset($row->service_cur_time) ? $row->service_cur_time : $row->cur_time) - $timestamp;
							$shown[] = $row;
						}
						continue 2;
					}
				}
			}
			$service_data = array();
			foreach ($shown as $service)
				$service_data[$service->service_id] = (isset($service->service_cur_time) ? $service->service_cur_time : $service->cur_time) - (isset($service->service_duration) ? $service->service_duration : $service->duration);
			$new_data[$group] = array('timestamp' => time(), 'last_shown' => $service_data);
		}

		if ($this->field === '-duration') {
			usort($shown, 'sort_by_duration');
			if ($this->order === 'DESC')
				$shown = array_reverse($shown);
		}

		if (isset($this->arguments['grouplog'])) {
			$new_data = array_merge($this->arguments['grouplog'], $new_data);
		}

		$this->model->merge_settings(array('grouplog' => $new_data));
		$this->model->save();

		return $shown;
	}

	private function remove_service($service_id) {
		if (isset($this->model->setting['grouplog']) && isset($this->model->setting['grouplog'][$this->arguments['group']]) && isset($this->model->setting['grouplog'][$this->arguments['group']]['last_shown']))
			unset($this->model->setting['grouplog'][$this->arguments['group']]['last_shown'][$service_id]);
		$db = new Database();
		$sql = "DELETE FROM widget_service_was_noticed WHERE service_id = {$db->escape($service_id)}";
		$db->query($sql);
		$sql = "INSERT INTO widget_service_was_noticed (service_id, timestamp) VALUES ({$db->escape($service_id)}, UNIX_TIMESTAMP())";
		$db->query($sql);
	}

	public function options()
	{
		$options = parent::options();
		$options[] = new option('tac_services_unacknowledged', 'backlog', 'Backlog', 'checkbox', array(), false);
		$options[] = new option('tac_services_unacknowledged', 'hard', 'Hard', 'checkbox', array(), true);
		return $options;
	}

	public function index()
	{
		$view_path = $this->view_path('unack-view');

		$this->setup();

		if (isset($_GET['ack_service']))
			$this->remove_service($_GET['ack_service']);

		$this->props = nagstat::SERVICE_STATE_UNACKNOWLEDGED | nagstat::SERVICE_CHECKS_ENABLED | nagstat::HOST_NO_SCHEDULED_DOWNTIME;
		if ($this->arguments['hard'])
			$this->props |= nagstat::SERVICE_HARD_STATE;

		if ($this->arguments['backlog']) {
			$this->props &= ~(nagstat::SERVICE_HARD_STATE); // just because it's not in a hard state Right Now...
			$result = $this->get_all_since_last($this->arguments['group']);
		}
		else {
			// if we just stopped showing the problem backlog, throw away stale data
			if (isset($this->arguments['group']) && !empty($this->arguments['group'])) {
				$this->model->merge_settings(array('grouplog' => array()));
				$this->model->save();
			}
			if ($this->arguments['group'] != 'all')
				$result = $this->service($this->arguments['group'], false, $this->state, $this->props, $this->order, $this->field, 'servicegroup');
			else
				$result = $this->service($this->arguments['group'], false, $this->state, $this->props, $this->order, $this->field);

		}

		$this->js[] = 'js/tac_services_unacknowledged';
		require($view_path);
	}
}
